
class LinkedList {
  private Object object;
  
  private LinkedList next = null;
  private LinkedList previous = null;
  
  public LinkedList getNext(){
    return next;
  }
  
  public LinkedList getPrevious(){
    return previous;
  }
  
  public LinkedList insertBefore(Object o){
   LinkedList l = new LinkedList(o);

   l.next = this;
   l.previous = this.previous;
   this.previous = l;
   
   return l; 
  }

  public LinkedList insertAfter(Object o){
   LinkedList l = new LinkedList(o);

   l.previous = this;
   l.next = this.next;
   this.next = l;
   
   return this;    
  }
  
  public String getValueAsString(){
    String s = "";
    if(object!=null){
      s = (String) object;
    }
    return s;
  }
  
  public LinkedList(Object o){
    object = o;
  }
  
  public int length(){
    int retval = 1;
    if(next!=null){
      retval = retval + next.length();
    }
    return retval;
  }
  
public void debugPrint(){
  
  int cnt = 0;
  for(LinkedList c = this; c!=null; c = c.next){
      println("LinkedList: Item " + cnt + " " + c.getValueAsString());
      cnt+=1;
  }
  
}
 
}
